package org.dromara.web.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.web.domain.ProductManufacturer;
import org.dromara.web.domain.bo.ProductManufacturerBo;
import org.dromara.web.domain.vo.ProductManufacturerVo;
import org.dromara.web.mapper.ProductManufacturerMapper;
import org.dromara.web.service.IProductManufacturerService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 生产厂商Service业务层处理
 *
 * @author Lion Li
 * @date 2025-07-07
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ProductManufacturerServiceImpl implements IProductManufacturerService {

    private final ProductManufacturerMapper baseMapper;

    /**
     * 查询生产厂商
     *
     * @param id 主键
     * @return 生产厂商
     */
    @Override
    public ProductManufacturerVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询生产厂商列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 生产厂商分页列表
     */
    @Override
    public TableDataInfo<ProductManufacturerVo> queryPageList(ProductManufacturerBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ProductManufacturer> lqw = buildQueryWrapper(bo);
        Page<ProductManufacturerVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的生产厂商列表
     *
     * @param bo 查询条件
     * @return 生产厂商列表
     */
    @Override
    public List<ProductManufacturerVo> queryList(ProductManufacturerBo bo) {
        LambdaQueryWrapper<ProductManufacturer> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ProductManufacturer> buildQueryWrapper(ProductManufacturerBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ProductManufacturer> lqw = Wrappers.lambdaQuery();
        lqw.orderByDesc(ProductManufacturer::getCreateTime);
        lqw.like(StringUtils.isNotBlank(bo.getName()), ProductManufacturer::getName, bo.getName());
        return lqw;
    }

    /**
     * 新增生产厂商
     *
     * @param bo 生产厂商
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ProductManufacturerBo bo) {
        ProductManufacturer add = MapstructUtils.convert(bo, ProductManufacturer.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改生产厂商
     *
     * @param bo 生产厂商
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ProductManufacturerBo bo) {
        ProductManufacturer update = MapstructUtils.convert(bo, ProductManufacturer.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ProductManufacturer entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除生产厂商信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
